#include "system.h"
#include "db.h"

#undef  CLOSESET
#undef  UPSET
#define DOWNSET
#undef  VERIFY1
#undef  VERIFY2
#define DELETE

#define MAXENTRIES	9
#define MAXKEYS		(MAXENTRIES * 2 + 1)

#define DBID		1
#define RELID		1
#define FLDID		1

char Key[MAXKEYS][15] = {
    "abracadabra",
    "alcatraz",
    "apple",
    "baseball",
    "breathing",
    "creature",
    "cretin",
    "daffodil",
    "dragon",
    "egg",
    "elephant",
    "fighter",
    "fool",
    "gate",
    "grate",
    "highrise",
    "hotel",
    "ignorance",
    "iguana"
};

struct index {
    struct index *i_next;
    struct index *i_prev;
    int i_tid;
} Index[MAXKEYS];

int EntryCount;

abort(s1, n1, s2, n2, s3)
char *s1, *s2, *s3;
int n1, n2;
{
    d_print(s1);
    d_pNum(n1);
    d_print(s2);
    d_pNum(n2);
    d_print(s3);
    d_crlf();
    exit(1);
}

#ifdef VERIFY1

verify1()
{
    long zero, tid1, tid2;
    
    if (strtLow(99, RELID, FLDID) & strtLow(98, RELID, FLDID)) {
	zero = 0L;
	d_print("verify1: ");
	for (;;) {
	    tid1 = fNext(99);
	    tid2 = fNext(98);
	if (tid1 == zero || tid2 == zero) break;
	    if (tid1 < zero) {
		abort("verify1 scan got negative: ", (int)tid1, " ", 1, "");
	    }
	    if (tid2 < zero) {
		abort("verify1 scan got negative: ", (int)tid2, " ", 2, "");
	    }
	    d_pNum((int)tid1);
	    d_print(":");
	    d_pNum((int)tid2);
	    d_print(" ");
	}
	d_crlf();
    } else if (EntryCount != 1) {
	d_print("verify strtLow failed");
	d_crlf();
	exit(1);
    }
}

#endif

#ifdef VERIFY2

ptr(i)
struct index *i;
{
    if (i == 0) {
	d_print("nil");
    } else {
	d_pNum(i - &Index[0]);
    }
}

verify2()
{
    struct index *i;
    int j;

    i = &Index[0];
    for (j = 0; j != EntryCount * 2 + 1; j += 1) {
	d_pNum(j);
	d_print(": n=");
	ptr(i->i_next);
	d_print(", p=");
	ptr(i->i_prev);
	d_print(", t=");
	d_pNum(i->i_tid);
	d_crlf();
	++i;
    }
}

#endif

check(forw, scan, pos)
int forw;
int scan, pos;
{
    long zero, tid;
    struct index *i;

    if (EntryCount == 1) {
	tid = forw ? fNext(scan) : fPrev(scan);
	if ((int)tid != 0) {
	    abort("scan ", scan, " got tid ", (int)tid, " instead of NULL");
	}
    } else {
	zero = 0L;
	i = &Index[pos];
	if (forw) {
	    if (i->i_tid == 0) {
		i = i->i_next;
	    }
	    tid = fNext(scan);
	} else {
	    if (i->i_tid == 0) {
		i = i->i_prev;
	    }
	    tid = fPrev(scan);
	}
	if (tid < zero) {
	    abort("scan ", scan, " got tid ", (int)tid, "");
	}
	while (i != 0 && (int)tid != 0) {
	    if (forw) {
		i = i->i_next;
		tid = fNext(scan);
	    } else {
		i = i->i_prev;
		tid = fPrev(scan);
	    }
	    if (tid < zero) {
		abort("scan ", scan, " got tid ", (int)tid, "");
	    }
	}
	if (i != 0) {
	    abort("scan ", scan, " failed early at ", i->i_tid, "");
	} else if (tid != 0) {
	    abort("scan ", scan, " got ", tid, " as extra");
	}
    }
}

scan(scan, pos)
int scan, pos;
{

    if (EntryCount != 1 || scan == 3 || scan == 4 || scan >= 7) {
	if (!scanString(scan, RELID, FLDID, Key[pos])) {
	    abort("fAllString for scan ", scan, " failed, pos = ", pos, "");
	}
    }
}

main()
{
    struct index *i;
    int tid, gotTid, delTid;
    int j, k;

    dbInit();
    dbOpen("DBTEST");
    rOpen(DBID, '0', "DBTEST");
    for (EntryCount = 1; EntryCount <= MAXENTRIES; EntryCount += 1) {
	d_print("Testing for ");
	d_pNum(EntryCount);
	d_print(" entries:");
	d_crlf();
	for (delTid = 1; delTid <= EntryCount; delTid += 1) {
	    for (tid = 1; tid <= EntryCount; tid += 1) {
		gotTid = tAlloc(RELID);
		j = tid * 2;
		i = &Index[j - 2];
		i->i_next = &Index[j - 1];
		i->i_prev = &Index[j - 3];
		i->i_tid = 0;
		++i;
		i->i_next = &Index[j + 1];
		i->i_prev = &Index[j - 3];
		i->i_tid = gotTid;
		++i;
		i->i_next = &Index[j + 1];
		i->i_prev = &Index[j - 1];
		i->i_tid = 0;
		pfString(RELID, (long)gotTid, FLDID, Key[j - 1]);
	    }
	    Index[0].i_prev = 0;
	    Index[1].i_prev = 0;
	    Index[EntryCount * 2 - 1].i_next = 0;
	    Index[EntryCount * 2].i_next = 0;
#ifdef CLOSESET
	    scan(1, delTid * 2 - 2);
	    scan(2, delTid * 2 - 2);
	    scan(3, delTid * 2 - 1);
	    scan(4, delTid * 2 - 1);
	    scan(5, delTid * 2    );
	    scan(6, delTid * 2    );
#endif
#ifdef UPSET
	    for (j = 1; j <= EntryCount; j += 1) {
		if (!strtLow(j + 6, RELID, FLDID)) {
		    abort("strtLow(", j + 6, ") failed", 0, "");
		}
		for (k = 1; k != j; k += 1) {
		    fNext(j + 6);
		}
	    }
#endif
#ifdef DOWNSET
	    for (j = 1; j <= EntryCount; j += 1) {
		if (!strtHigh(j + EntryCount + 6, RELID, FLDID)) {
		    abort("strtHigh(", j + EntryCount + 6,") failed", 0, "");
		}
		for (k = 1; k != j; k += 1) {
		    fPrev(j + EntryCount + 6);
		}
	    }
#endif
#ifdef DELETE
	    j = Index[delTid * 2 - 1].i_tid;
	    if (chkTuple(RELID, (long)j) != 0) {
		abort("tuple ", j, " isn't in use ", 0, "");
	    }
	    tFree(RELID, (long)j);
#endif
	    if (EntryCount != 1) {
#ifdef DELETE
		if (delTid == 1) {
		    Index[2].i_prev = 0;
		    Index[3].i_prev = 0;
		} else {
		    Index[delTid * 2    ].i_prev = &Index[delTid * 2 - 3];
		    if (delTid != EntryCount) {
			Index[delTid * 2 + 1].i_prev= &Index[delTid * 2 - 3];
		    }
		}
		if (delTid == EntryCount) {
		    Index[EntryCount * 2 - 3].i_next = 0;
		    Index[EntryCount * 2 - 2].i_next = 0;
		} else {
		    if (delTid != 1) {
			Index[delTid * 2 - 3].i_next= &Index[delTid * 2 + 1];
		    }
		    Index[delTid * 2 - 2].i_next = &Index[delTid * 2 + 1];
		}
		Index[delTid * 2 - 1].i_tid = 0;
#endif
#ifdef CLOSESET
		check(false, 1, delTid * 2 - 2);
		check(true, 2, delTid * 2 - 2);
#endif
	    }
#ifdef CLOSESET
	    check(false, 3, delTid * 2 - 1);
	    check(true, 4, delTid * 2 - 1);
	    if (EntryCount != 1) {
		check(false, 5, delTid * 2);
		check(true, 6, delTid * 2);
	    }
#endif
#ifdef UPSET
	    for (j = 1; j <= EntryCount; j += 1) {
		check(true, j + 6, j * 2 - 1);
	    }
#endif
#ifdef DOWNSET
	    for (j = 1; j <= EntryCount; j += 1) {
		check(false, j + EntryCount + 6, (EntryCount - j) * 2 + 1);
	    }
#endif
	    for (tid = 1; tid <= EntryCount; tid += 1) {
		if (chkTuple(RELID, (long)tid) == 0) {
		    tFree(RELID, (long)tid);
		}
	    }
	}
    }
    dbTerm();
}
